<?php
namespace app\download\index;

use app\common\controller\index\Order AS _Order;
//use app\common\util\Shop AS ShopFun;

//下单
class Order extends _Order
{
    /**
     * 提交订单
     * {@inheritDoc}
     * @see \app\common\controller\index\Order::add()
     */
    public function add(){
        $result = $this->check_jifen();
        if (!is_numeric($result)) { //检查用户是否有足够的积分
            $this->error($result);
        }
        
        if ($this->request->isPost()==false) {
            $this->assign('money',$this->check_rmb());
            $this->assign('jifen',$result);
        }
        return parent::add();
	}
		

    /**
     * 付款完毕
     * {@inheritDoc}
     * @see \app\common\controller\index\Order::endpay()
     */
    public function endpay($order_id = ''){
        return parent::endpay($order_id);
    }
    
    /**
     * ajax可用积分判断
     * @return unknown
     */
    public function check(){
        $result = $this->check_jifen();
        if (!is_numeric($result)) {
            return $this->err_js($result);
        }else{
            return $this->ok_js($result);
        }
    }
    
    /**
     * 订单提交成功后执行的操作
     * @param array $order_ids 订单id数组
     * @param array $car_ids 购物车id数组
     */
    protected function end_add($order_ids=[],$car_ids=[]){
        if (empty($order_ids)) {
            return ;
        }
		
        //购物车实际只有一个商品
        $listdb = $this->car_model->getList($this->user['uid'],1);        
        foreach ($listdb AS $uid=>$shop_array){
            $jifen = 0;
            foreach ($shop_array AS $rs){   //这里实际只有一个商品
                $jifen +=  $rs['jifen'] * $rs['_car_']['num'];
            }
            
            if ($jifen>0) {
				$url = urls('content/show','id='.$rs['id']);
                add_jifen($uid, abs($jifen),'销售积分商品:'.$rs['title']);
                add_jifen($this->user['uid'], -abs($jifen),'兑换积分商品:'.$rs['title']);
                send_msg($uid,'有人兑换积分商品了',$this->user['username']." 在积分商城兑换了商品:".$rs['title']);
				send_msg($this->user['uid'],'您好！您成功用积分兑换了商品',$this->user['username']."您好！您在积分商城兑换了商品，请返回内容页进行下载，该主题是：<a href=\"{$url}\" target=\"_blank\">{$rs['title']}</a>！");
            }
        }
        
        $money = $this->check_rmb();        
        if ($money===0||$money===0.00) {    //0元商品,设置为已支付
            $data = [
                    'id'=>$order_ids[0],    //只针对只有一个商家的情况.
                    'pay_status'=>1,
                    'user_jf'=>$jifen,
                    'pay_time'=>time(),
            ];            
        }else{
            $data = [
                    'id'=>$order_ids[0],    //只针对只有一个商家的情况.
                    'user_jf'=>$jifen,
            ]; 
        }
        $this->order_model->update($data);
        
        $this->car_model->destroy($car_ids);
		

		
    }
    
    /**
     * 检查需要多少积分才能兑换
     * @return string|number
     */
    protected function check_jifen(){
        $listdb = $this->car_model->getList($this->user['uid'],1);
        $jifen = 0;
        foreach ($listdb AS $uid=>$shop_array){
            foreach ($shop_array AS $rs){   //实际只有一个商品
                $jifen +=  abs($rs['jifen']) * $rs['_car_']['num'];
            }
        }
        if ($this->user['money']<$jifen) {
            return '本次需要消费积分 ' . $jifen . ' 个,你仅有 ' . $this->user['money'] . '个,无法提交订单';
        }
        return $jifen;
    }
    
    /**
     * 检查是否需要支付人民币
     * @return string|number
     */
    protected function check_rmb(){
//         $listdb = $this->car_model->getList($this->user['uid'],1);
//         $money = 0;
//         foreach ($listdb AS $uid=>$shop_array){
//             foreach ($shop_array AS $rs){   //某个商家的多个商品
//                 $_shop[] = $rs['_car_']['shopid'] . '-' . $rs['_car_']['num']  . '-' . $rs['_car_']['type1'] . '-' .$rs['_car_']['type2'] . '-' .$rs['_car_']['type3'];
//                 $money += ShopFun::get_price($rs,$rs['_car_']['type1']-1);
//             }
//         }
        $money = fun('shop@car_money');
        return $money;
    }
    
} 